//***************************************************************************
//  sensor.c
//***************************************************************************

//***************************************************************************
// read IR sensor (LEFT or RIGHT). Higher values represent more IR
// reflections being detected
//***************************************************************************
unsigned char read_range(unsigned char dir){
  unsigned char left=0,right=0;
  unsigned char i=0;
  
  left=0;right=0;
 IR_ENABLE = 1; // Enable 555 timer (IR On)
 
  for(i=0;i<100;i++){
    if (IR_LEFT==0) left++;
    if (IR_RIGHT==0) right++;
    delay_us(5);
  }  
  IR_ENABLE = 0; // Disable 555 timer (IR Off)

  if(dir==LEFT){
    return(left);
  } else if (dir==RIGHT){
    return(right);
  }
  return 0; // should never get here unless a bad direction was passed to us    
}

void ReadSensors()
{  	
	leftRange = read_range(LEFT);

	if (leftRange <= RANGE_MIN_VALUE)
		leftRange = 0;
	if (leftRange != 0 && leftRange >= RANGE_MAX_VALUE)
		leftContact = TRUE;
	else
		leftContact = FALSE;
	
	rightRange = read_range(RIGHT);

	if (rightRange <= RANGE_MIN_VALUE)
		rightRange = 0;
	if (rightRange != 0 && rightRange > RANGE_MAX_VALUE)
		rightContact = TRUE;
	else
		rightContact = FALSE;

	if (leftContact && rightContact)
	{
  	   ObjectStraightAhead = 1;
	}
	else 
	{
	  ObjectStraightAhead = 0;
	}

} // End of ReadSensors()
